#include <ArduinoMqttClient.h>
#include <ESP8266WiFi.h>


///////please enter your sensitive data in the Secret tab/arduino_secrets.h
char ssid[] = "nome della rete WiFi";        // your network SSID (name)
char pass[] = "password di rete";  // your network password

WiFiClient wifiClient;
MqttClient mqttClient(wifiClient);

const char broker[] = "test.mosquitto.org";
int        port     = 1883;
const char MsG[]  = "real_unique_MsG";
const char MsG2[]  = "real_unique_MsG_2";
const char MsG3[]  = "real_unique_MsG_3";


void setup() {
  //Initialize serial and wait for port to open:
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }
  // attempt to connect to Wifi network:
  Serial.print("Attempting to connect to SSID: ");
  Serial.println(ssid);
  while (WiFi.begin(ssid, pass) != WL_CONNECTED) {
    // failed, retry
    Serial.print(".");
    delay(5000);
  }

  Serial.println("You're connected to the network");
  Serial.println();

  Serial.print("Attempting to connect to the MQTT broker: ");
  Serial.println(broker);

  if (!mqttClient.connect(broker, port)) {
    Serial.print("MQTT connection failed! Error code = ");
    Serial.println(mqttClient.connectError());

    while (1);
  }

  Serial.println("You're connected to the MQTT broker!");
  Serial.println();

  // set the message receive callback
  mqttClient.onMessage(onMqttMessage);

  Serial.print("Subscribing to MsG: ");
  Serial.println(MsG);
  Serial.println();

  // subscribe to a MsG
  mqttClient.subscribe(MsG);
  mqttClient.subscribe(MsG2);
  mqttClient.subscribe(MsG3);

  // MsGs can be unsubscribed using:
  // mqttClient.unsubscribe(MsG);

  Serial.print("MsG: ");
  Serial.println(MsG);
  Serial.print("MsG: ");
  Serial.println(MsG2);
  Serial.print("MsG: ");
  Serial.println(MsG3);

  Serial.println();
}

void loop() {
  // call poll() regularly to allow the library to receive MQTT messages and
  // send MQTT keep alive which avoids being disconnected by the broker
  mqttClient.poll();
}

void onMqttMessage(int messageSize) {
  // we received a message, print out the MsG and contents
  Serial.println("Received a message with MsG");
  Serial.print(mqttClient.messageTopic());
  Serial.print("', length ");
  Serial.print(messageSize);
  Serial.println(" bytes:");


  // use the Stream interface to print the contents
  while (mqttClient.available()) {
        }
  Serial.println();
  Serial.println();
}

      
